// Global vars
var KK_CLIENT_OS = "";
var KK_CLIENT_OS_VERSION = "";
var KK_CLIENT_VERSION = "";
var KK_PAGE_NAME = "";
var KK_SCREEN_WIDTH = 480;
var KK_SCREEN_HEIGHT = 800;
var KK_ANDROID_DENSITY = 1.0;
var KK_LANG;

var KK_IMAGE_DE_RATE = 4.5;
var mImageSize = 65;

var KK_IS_DEBUG_MODE = false;

function initEnvParams(os, lang, appServer, currentPageName, screenWidth, screenHeight, osVersion, clientVersion) {
	KK_CLIENT_OS = os? os : urlParam('os');
	KK_LANG = lang? lang : urlParam('lang');
	KK_APPS_SERVER = appServer? appServer : urlParam('appServer');
	KK_CLIENT_OS_VERSION = osVersion? osVersion : urlParam('osVersion');
	KK_CLIENT_VERSION = clientVersion? clientVersion : urlParam('clientVersion');
	KK_SCREEN_WIDTH = screenWidth? screenWidth : urlParam('screenWidth');
	KK_SCREEN_HEIGHT = screenHeight? screenHeight : urlParam('screenHeight');
	KK_PAGE_NAME = currentPageName? currentPageName : urlParam('currentPageName');
	KK_APPS_DOMAIN = getAppDomainByType(KK_APPS);
	KK_FILE_DOMAIN = getAppDomainByType(KK_FILES);
	KK_FROYO_DOMAIN = getAppDomainByType(KK_FORYO);
	KK_ANDROID_DENSITY = window.devicePixelRatio; 
	
	caculateImageSize();
}

function caculateImageSize() {
	if ("" != KK_SCREEN_WIDTH && KK_ANDROID_DENSITY > 0) {
		if (navigator.userAgent.match(/(iPhone).*OS\s([\d_]+)/)) {
			if (KK_SCREEN_WIDTH == 768) {
				KK_SCREEN_WIDTH = 320;
			}
		}
		mImageSize = (KK_SCREEN_WIDTH / KK_ANDROID_DENSITY) / KK_IMAGE_DE_RATE;
	}
}

function initEnv(os, lang, appServer, pageName, width, height, osVersion, clientVersion) {
	initEnvParams(os, lang, appServer, pageName, width, height, osVersion, clientVersion);
	var text = resc.getResource();
	init_page(currPageData, text);
}

function init_plaza(){
	KK_CLIENT_OS = urlParam('os');
	if ("" == KK_CLIENT_OS) {	// NO url params. Wait native to call initEnv
		return;
	}
	initEnvParams();
	var text = resc.getResource();
	init_page(currPageData, text);
}

function init_page(_data, text) {
	var i,len=_data.length,_d,appId,appType,appVersion,appFullScreen,appUrl,appName;
	for(i=0;i<len;i++){
		_d=_data[i];
		_d["ImgWidth"] = mImageSize;
		_d["ImgHeight"] = mImageSize+2;
		_d["Class"] = "ui-block";
		
		appId = _d["Id"];
		appName= text[ appId ];
		_d["Text"]= appName;
		appType = _d["Type"];
		appVersion = _d["Version"];
		appFullScreen = _d["Fullscreen"];
		if ("web_online" == appType || "web_offline" == appType) {
			appUrl =_d["Url"];
			if (appUrl) {
				appUrl = getAppUrl(appType, appUrl, appVersion);
			} else {
				appUrl = getAppUrlWithId(appType, appId, appVersion);
			}
		}
		var href = getAppLink(KK_PAGE_NAME, KK_CLIENT_OS, appType, appId, appFullScreen, appName, appUrl);
		_d["Link"]=href;
	}
	var html=document.getElementById("template").innerHTML;
	var T = new Template(html);
	document.getElementById('ul-content').innerHTML=T.getText(_data);
	var alinks=document.getElementsByTagName("a");
	var alink;
	for (var i=0,len=alinks.length;i<len;i++) {
		alink = alinks[i];
		alink.ontouchstart = function(e) {
			e.stopPropagation();
			var src = e.target.parentNode;
			if (src.className.indexOf('appclicked')<0) {
				src.className+=' appclicked';
			}
		}
		alink.ontouchmove = function(e) {
			e.stopPropagation();
		}
		alink.ontouchend = function(e) {
			cancelTouch(e);
		}
		alink.ontouchcancel = function(e) {
			cancelTouch(e);
		}
	}
}

function cancelTouch(e) {
	if (e && e.target) {
		var src = e.target.parentNode;
		src.className=src.className.replace('appclicked','');
	} else {
		var tapped = document.querySelectorAll("a.appclicked");
		if (tapped) {
			for (var i=0;i<tapped.length;i++) {
				src = tapped[i];
				src.className = src.className.replace(" appclicked", "");
			}
		}
	}
}

function goto(url){
	window.location.href=url;
}

function getAppUrl(appType, appUrl, appVersion) {
	appUrl = getAppDomain(KK_APPS) + appUrl;
	return encodeURIComponent(appUrl);
}

function getAppUrlWithId(appType, appId, appVersion) {
	appUrl = getAppDomain(KK_APPS) + "/" + appId;
	return encodeURIComponent(appUrl);
}

/* get from utils.js */
Object.prototype.clone = function(){
	var objClone;
	if (this.constructor == Object){
		objClone = new this.constructor(); 
	}else{
		objClone = new this.constructor(this.valueOf()); 
	}
	for(var key in this){
		if ( objClone[key] != this[key] ){ 
			if ( typeof(this[key]) == 'object' ){ 
				objClone[key] = this[key].clone();
			}else{
				objClone[key] = this[key];
			}
		}
	}
	objClone.toString = this.toString;
	objClone.valueOf = this.valueOf;
	return objClone; 
}
function Template(template){
	function parse(template){
		var a=template.split("_{");
		var ac=a.length;
		for(var i=1;i<ac;i++){
			a[i] = a[i].split("}_");
		}
		return a;
	}
	function _replace(d,a){
		var i,ic=a.length,k;
		for(i=1;i<ic;i++){
			k=a[i][0];
			if(k){
				a[i][0]=d[k];
				a[i]=a[i].join("");
			}
		}
		return a.join("");
	}
	function replace(d){
		var a=parse(template);
		var i,ic=d.length,ar=new Array();
		for(i=0;i<ic;i++){
			ar.push(_replace(d[i],a.clone()));
		}
		return ar;
	}
	this.getText=function(data){
		return replace(data).join("");
	}
}

//广场的json数据
var plazaData = [
    //第一页
	[{
	    Id: '5',
	    Type: 'native',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/virtual_trip.png'
	},{
	    Id: '1',
	    Type: 'native',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/nearby_actions.png'
	},{
        Id: '113',
        Type: 'web_online',
        Version: '1',
        Fullscreen: 'false',
        Image: 'images/ranking.png',
        Url: '/ranking.do'
    },{
	    Id: '115',
	    Type: 'web_online',
	    Version: '1',
	    Fullscreen: 'true',
	    Image: 'images/focus.png',
	    Url: '/focus.do'
	},{
	    Id: '111',
	    Type: 'web_online',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/vip.png',
	    Url: '/vip.do'
	},{
	    Id: '110',
	    Type: 'web_online',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/fortune.png',
	    Url: '/kmoney.do'
	},{
	    Id: '6',
	    Type: 'native',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/bulk_wink.png'
	},{
	    Id: '114',
	    Type: 'web_online',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/promotion.png',
	    Url: '/promotion.do'
	},{
	    Id: '112',
	    Type: 'web_online',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/attention_me.png',
	    Url: '/attention_me.do'
	},{
	    Id: '4',
	    Type: 'native',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/see_me.png'
	},{
	    Id: '3',
	    Type: 'native',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/my_attention.png'
	},{
	    Id: '7',
	    Type: 'native',
	    Version: '1',
	    Fullscreen: 'false',
	    Image: 'images/settings.png'
	}]
];
function getPlazaData (idx) {
	var size = plazaData.length;
	if (idx>=0 && idx<size) {
		return plazaData[idx];
	}
	return plazaData;
}

var resc = new Resource();
resc.setResource(ZH_CN,{
            "1":"周边动态",
            "110":"我的财富",
            "3":"我的关注",
            "4":"谁看过我",
            "5":"穿越",
            "112":"谁关注我",
            "111":"VIP会员",
            "6":"群发电眼",
            "7":"设置",
            "113":"魅力排行",
            "114":"活动",
            "115":"我是焦点"
    });
resc.setResource(ZH_TW,{
            "1":"周邊動態",
            "110":"我的財富",
            "3":"我的關注",
            "4":"誰看過我",
            "5":"穿越",
            "112":"誰關注我",
            "111":"VIP會員",
            "6":"群發電眼",
            "7":"設置",
            "113":"魅力排行",
            "114":"活動",
            "115":"我是焦點"
    });
resc.setResource(EN_US,{
            "1":"Nearby",
            "110":"Fortune",
            "3":"Following",
            "4":"Look at me",
            "5":"Travel",
            "112":"Followers",
            "111":"VIP",
            "6":"Bulk Wink",
            "7":"Settings",
            "113":"Ranking",
            "114":"Promotion",
            "115":"Show Me"
    });